Whamcloud - gitweb
LU-5810 tests: add client hostname to lctl mark
[fs/lustre-release.git] / lustre / tests / sanityn.sh
old mode 100644 (file)
new mode 100755 (executable)
index 2f5ab1b..738c837
@@ -3,23 +3,15 @@
 set -e
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test: 3192 LU-1205 15528/3811 16929 9977 15528/11549 18080
-ALWAYS_EXCEPT="                14b  18c     19         22    28   29          35    $SANITYN_EXCEPT"
+# bug number for skipped test: 3192 LU-1205 15528/3811 9977 15528/11549 18080
+ALWAYS_EXCEPT="                14b  18c     19         28   29          35    $SANITYN_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
-# bug number for skipped test:        12652 12652
-grep -q 'Enterprise Server 10' /etc/SuSE-release 2> /dev/null &&
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 11    14" || true
-
-# It will be ported soon.
-EXCEPT="$EXCEPT 22"
-
-SRCDIR=`dirname $0`
+SRCDIR=$(dirname $0)
 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
 
 SIZE=${SIZE:-40960}
 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
-MCREATE=${MCREATE:-mcreate}
 OPENFILE=${OPENFILE:-openfile}
 OPENUNLINK=${OPENUNLINK:-openunlink}
 export MULTIOP=${MULTIOP:-multiop}
@@ -41,12 +33,12 @@ init_test_env $@
 init_logging
 
 if [ $(facet_fstype $SINGLEMDS) = "zfs" ]; then
-# bug number for skipped test:        LU-2840 LU-2189 LU-2776
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 21      36      51a"
+# bug number for skipped test:        LU-2189 LU-2776
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 36      51a"
 # LU-2829 / LU-2887 - make allowances for ZFS slowness
        TEST33_NFILES=${TEST33_NFILES:-1000}
 fi
-
+#                                  23   (min)"
 [ "$SLOW" = "no" ] && EXCEPT_SLOW="33a"
 
 FAIL_ON_ERROR=false
@@ -56,9 +48,6 @@ TRACE=${TRACE:-""}
 
 check_and_setup_lustre
 
-LOVNAME=$($LCTL get_param -n llite.*.lov.common_name | tail -n 1)
-OSTCOUNT=$($LCTL get_param -n lov.$LOVNAME.numobd)
-
 assert_DIR
 rm -rf $DIR1/[df][0-9]* $DIR1/lnk $DIR/[df].${TESTSUITE}*
 
@@ -172,6 +161,18 @@ test_2f() {
 }
 run_test 2f "check attr/owner updates on DNE with 2 mtpt's"
 
+test_2g() {
+       dd if=/dev/zero of=$DIR1/$tfile oflag=sync bs=1M count=2
+
+       local block1=$(stat $DIR1/$tfile | awk '/Blocks/ {print $4} ')
+       cancel_lru_locks osc
+       local block2=$(stat $DIR2/$tfile | awk '/Blocks/ {print $4} ')
+       echo "$DIR1/$tfile has $block1 blocks"
+       echo "$DIR2/$tfile has $block2 blocks"
+       [ $block1 -eq $block2 ] || error
+}
+run_test 2g "check blocks update on sync write"
+
 test_3() {
        local target="this/is/good"
        ln -s $target $DIR1/$tfile || error "ln -s $target $DIR1/$tfile failed"
@@ -293,7 +294,7 @@ test_13() { # bug 2451 - directory coherency
 }
 run_test 13 "test directory page revocation ===================="
 
-test_14() {
+test_14aa() {
        test_mkdir -p $DIR1/$tdir
        cp -p /bin/ls $DIR1/$tdir/$tfile
        multiop_bg_pause $DIR1/$tdir/$tfile Ow_c || return 1
@@ -303,9 +304,9 @@ test_14() {
        kill -USR1 $MULTIPID
        wait $MULTIPID || return 2
 }
-run_test 14 "execution of file open for write returns -ETXTBSY ="
+run_test 14aa "execution of file open for write returns -ETXTBSY"
 
-test_14a() {
+test_14ab() {
        test_mkdir -p $DIR1/d14
        cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
@@ -315,7 +316,7 @@ test_14a() {
         wait $MULTIOP_PID || return 3
         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
 }
-run_test 14a "open(RDWR) of executing file returns -ETXTBSY ===="
+run_test 14ab "open(RDWR) of executing file returns -ETXTBSY"
 
 test_14b() { # bug 3192, 7040
        test_mkdir -p $DIR1/d14
@@ -358,16 +359,6 @@ test_14d() { # bug 10921
 }
 run_test 14d "chmod of executing file is still possible ========"
 
-test_14e() { # LU-4398
-       test_mkdir -p $DIR1/$tdir
-       rm -f $DIR1/$tdir/echo
-       cp /bin/echo $DIR1/$tdir/echo
-       $DIR1/$tdir/echo Hi
-       $DIR1/$tdir/echo Hi
-       echo Bye > $DIR2/$tdir/echo
-}
-run_test 14e "conflicting locks are flushed on open"
-
 test_15() {    # bug 974 - ENOSPC
        echo "PATH=$PATH"
        sh oos2.sh $MOUNT1 $MOUNT2
@@ -768,14 +759,14 @@ test_32a() { # bug 11270
         log "checking cached lockless truncate"
         $TRUNCATE $DIR1/$tfile 8000000
         $CHECKSTAT -s 8000000 $DIR2/$tfile || error "wrong file size"
-        [ $(calc_osc_stats lockless_truncate) -eq 0 ] ||
-                error "lockless truncate doesn't use cached locks"
+       [ $(calc_osc_stats lockless_truncate) -ne 0 ] ||
+               error "cached truncate isn't lockless"
 
         log "checking not cached lockless truncate"
         $TRUNCATE $DIR2/$tfile 5000000
         $CHECKSTAT -s 5000000 $DIR1/$tfile || error "wrong file size"
-        [ $(calc_osc_stats lockless_truncate) -ne 0 ] ||
-                error "not cached trancate isn't lockless"
+       [ $(calc_osc_stats lockless_truncate) -ne 0 ] ||
+               error "not cached truncate isn't lockless"
 
         log "disabled lockless truncate"
         enable_lockless_truncate 0
@@ -934,7 +925,7 @@ test_33b() {
                avgjbd=0
                avgtime=0
                for i in 1 2 3; do
-                       do_node $CLIENT1 "$LFS mkdir -i $MDTIDX -p \
+                       do_node $CLIENT1 "$LFS mkdir -i $MDTIDX \
                                          $DIR1/$tdir-\\\$(hostname)-$i"
 
                        jbdold=$(print_jbd_stat)
@@ -967,6 +958,118 @@ test_33b() {
 }
 run_test 33b "COS: cross create/delete, 2 clients, benchmark under remote dir"
 
+test_33c() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.63) ] &&
+               skip "DNE CoS not supported" && return
+
+       sync
+
+       mkdir $DIR/$tdir
+       # remote mkdir is done on MDT2, which enqueued lock of $tdir on MDT1
+       $LFS mkdir -i 1 $DIR/$tdir/d1
+       do_facet mds1 "lctl set_param -n mdt.*.sync_count=0"
+       mkdir $DIR/$tdir/d2
+       local sync_count=$(do_facet mds1 \
+               "lctl get_param -n mdt.*MDT0000.sync_count")
+       [ $sync_count -eq 1 ] || error "Sync-Lock-Cancel not triggered"
+
+       $LFS mkdir -i 1 $DIR/$tdir/d3
+       do_facet mds1 "lctl set_param -n mdt.*.sync_count=0"
+       # during sleep remote mkdir should have been committed and canceled
+       # remote lock spontaneously, which shouldn't trigger sync
+       sleep 6
+       mkdir $DIR/$tdir/d4
+       local sync_count=$(do_facet mds1 \
+               "lctl get_param -n mdt.*MDT0000.sync_count")
+       [ $sync_count -eq 0 ] || error "Sync-Lock-Cancel triggered"
+}
+run_test 33c "Cancel cross-MDT lock should trigger Sync-Lock-Cancel"
+
+ops_do_cos() {
+       local nodes=$(comma_list $(mdts_nodes))
+       do_nodes $nodes "lctl set_param -n mdt.*.async_commit_count=0"
+       sh -c "$@"
+       local async_commit_count=$(do_nodes $nodes \
+               "lctl get_param -n mdt.*.async_commit_count" | calc_sum)
+       [ $async_commit_count -gt 0 ] || error "CoS not triggerred"
+
+       rm -rf $DIR/$tdir
+       sync
+}
+
+test_33d() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.63) ] &&
+               skip "DNE CoS not supported" && return
+
+       sync
+       # remote directory create
+       mkdir $DIR/$tdir
+       ops_do_cos "$LFS mkdir -i 1 $DIR/$tdir/subdir"
+       # remote directory unlink
+       $LFS mkdir -i 1 $DIR/$tdir
+       ops_do_cos "rmdir $DIR/$tdir"
+       # striped directory create
+       mkdir $DIR/$tdir
+       ops_do_cos "$LFS mkdir -c 2 $DIR/$tdir/subdir"
+       # striped directory setattr
+       $LFS mkdir -c 2 $DIR/$tdir
+       touch $DIR/$tdir
+       ops_do_cos "chmod 713 $DIR/$tdir"
+       # striped directory unlink
+       $LFS mkdir -c 2 $DIR/$tdir
+       touch $DIR/$tdir
+       ops_do_cos "rmdir $DIR/$tdir"
+       # cross-MDT link
+       $LFS mkdir -c 2 $DIR/$tdir
+       $LFS mkdir -i 0 $DIR/$tdir/d1
+       $LFS mkdir -i 1 $DIR/$tdir/d2
+       touch $DIR/$tdir/d1/tgt
+       ops_do_cos "ln $DIR/$tdir/d1/tgt $DIR/$tdir/d2/src"
+       # cross-MDT rename
+       $LFS mkdir -c 2 $DIR/$tdir
+       $LFS mkdir -i 0 $DIR/$tdir/d1
+       $LFS mkdir -i 1 $DIR/$tdir/d2
+       touch $DIR/$tdir/d1/src
+       ops_do_cos "mv $DIR/$tdir/d1/src $DIR/$tdir/d2/tgt"
+       # migrate
+       $LFS mkdir -i 0 $DIR/$tdir
+       ops_do_cos "$LFS migrate -m 1 $DIR/$tdir"
+       return 0
+}
+run_test 33d "DNE distributed operation should trigger COS"
+
+test_33e() {
+       [ -n "$CLIENTS" ] || { skip "Need two or more clients" && return 0; }
+       [ $CLIENTCOUNT -ge 2 ] ||
+               { skip "Need two or more clients, have $CLIENTCOUNT" &&
+                                                               return 0; }
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.63) ] &&
+               skip "DNE CoS not supported" && return
+
+       local client2=${CLIENT2:-$(hostname)}
+
+       sync
+
+       local nodes=$(comma_list $(mdts_nodes))
+       do_nodes $nodes "lctl set_param -n mdt.*.async_commit_count=0"
+
+       $LFS mkdir -c 2 $DIR/$tdir
+       mkdir $DIR/$tdir/subdir
+       echo abc > $DIR/$tdir/$tfile
+       do_node $client2 echo dfg >> $DIR/$tdir/$tfile
+       do_node $client2 touch $DIR/$tdir/subdir
+
+       local async_commit_count=$(do_nodes $nodes \
+               "lctl get_param -n mdt.*.async_commit_count" | calc_sum)
+       [ $async_commit_count -gt 0 ] && error "CoS triggerred"
+
+       return 0
+}
+run_test 33e "DNE local operation shouldn't trigger COS"
+
 # End commit on sharing tests
 
 get_ost_lock_timeouts() {
@@ -989,6 +1092,7 @@ cleanup_34() {
 }
 
 test_34() { #16129
+       remote_ost_nodsh && skip "remote OST with nodsh" && return
         local OPER
         local lock_in
         local lock_out
@@ -1038,8 +1142,9 @@ run_test 34 "no lock timeout under IO"
 test_35() { # bug 17645
         local generation=[]
         local count=0
-        for imp in /proc/fs/lustre/mdc/$FSNAME-MDT*-mdc-*; do
-            g=$(awk '/generation/{print $2}' $imp/import)
+       gen=$(lctl get_param mdc.$FSNAME-MDT*-mdc-*.import | grep generation |
+               awk '/generation/{print $2}')
+       for g in $gen; do
             generation[count]=$g
             let count=count+1
         done
@@ -1081,10 +1186,20 @@ test_35() { # bug 17645
         do_facet client "lctl set_param fail_loc=0x0"
         df -h $MOUNT1 $MOUNT2
         count=0
-        for imp in /proc/fs/lustre/mdc/$FSNAME-MDT*-mdc-*; do
-            g=$(awk '/generation/{print $2}' $imp/import)
-            if ! test "$g" -eq "${generation[count]}"; then
-                error "Eviction happened on import $(basename $imp)"
+       gen=$(lctl get_param mdc.$FSNAME-MDT*-mdc-*.import | grep generation |
+               awk '/generation/{print $2}')
+       for g in $gen; do
+           if ! test "$g" -eq "${generation[count]}"; then
+               list=$(lctl list_param mdc.$FSNAME-MDT*-mdc-*.import)
+               local c = 0
+               for imp in $list; do
+                       if [ $c = $count ]; then
+                               break
+                       fi
+                       c=c+1
+               done
+               imp=$(echo "$imp" | awk -F"." '{print $2}')
+               error "Eviction happened on import $imp"
             fi
             let count=count+1
         done
@@ -1104,7 +1219,7 @@ test_36() { #bug 16417
        sync; sleep 5; sync # wait for delete thread
 
        while [ $i -le 10 ]; do
-               lctl mark "start test"
+               lctl mark "$HOSTNAME start test loop $i"
                local before=$(lfs_df $MOUNT1 | awk '/^filesystem/{ print $4; exit }')
                dd if=/dev/zero of=$DIR1/$tdir/$tfile bs=1M count=$SIZE ||
                        error "dd $DIR1/$tdir/$tfile ${SIZE}MB failed"
@@ -1255,8 +1370,10 @@ check_pdo_conflict() {
 # pdirop tests
 # test 40: check non-blocking operations
 test_40a() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
+       touch $DIR2
        mkdir $DIR1/$tfile &
        PID1=$!
        sleep 1
@@ -1283,6 +1400,7 @@ test_40a() {
 run_test 40a "pdirops: create vs others =============="
 
 test_40b() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
        touch $DIR1/$tfile &
@@ -1312,6 +1430,7 @@ test_40b() {
 run_test 40b "pdirops: open|create and others =============="
 
 test_40c() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
        touch $DIR1/$tfile
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
@@ -1342,6 +1461,7 @@ test_40c() {
 run_test 40c "pdirops: link and others =============="
 
 test_40d() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
        touch $DIR1/$tfile
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
@@ -1371,6 +1491,7 @@ test_40d() {
 run_test 40d "pdirops: unlink and others =============="
 
 test_40e() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
        touch $DIR1/$tfile
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
@@ -2441,8 +2562,8 @@ run_test 54 "rename locking"
 test_55a() {
        mkdir -p $DIR/d1/d2 $DIR/d3 || error "(1) mkdir failed"
 
-#define OBD_FAIL_MDS_RENAME              0x153
-       do_facet mds $LCTL set_param fail_loc=0x80000153
+#define OBD_FAIL_MDS_RENAME4              0x156
+       do_facet mds $LCTL set_param fail_loc=0x80000156
 
        mv -T $DIR/d1/d2 $DIR/d3/d2 &
        PID1=$!
@@ -2459,8 +2580,8 @@ test_55b()
 {
        mkdir -p $DIR/d1/d2 $DIR/d3 || error "(1) mkdir failed"
 
-#define OBD_FAIL_MDS_RENAME              0x155
-       do_facet mds $LCTL set_param fail_loc=0x80000155
+#define OBD_FAIL_MDS_RENAME4             0x156
+       do_facet mds $LCTL set_param fail_loc=0x80000156
 
        mv -T $DIR/d1/d2 $DIR/d3/d2 &
        PID1=$!
@@ -2469,13 +2590,64 @@ test_55b()
        rm -r $DIR2/d1
        wait $PID1 && error "(2) mv succeeded"
 
-       rm -rf $DIR/d1
+       rm -rf $DIR/d3
 }
 run_test 55b "rename vs unlink source dir"
 
+test_55c()
+{
+       mkdir -p $DIR/d1/d2 $DIR/d3 || error "(1) mkdir failed"
+
+#define OBD_FAIL_MDS_RENAME4              0x156
+       do_facet mds $LCTL set_param fail_loc=0x156
+
+       mv -T $DIR/d1/d2 $DIR/d3/d2 &
+       PID1=$!
+       sleep 1
+
+       # while rename is sleeping, open and remove d3
+       $MULTIOP $DIR2/d3 D_c &
+       PID2=$!
+       sleep 1
+       rm -rf $DIR2/d3
+       sleep 5
+
+       # while rename is sleeping 2nd time, close d3
+       kill -USR1 $PID2
+       wait $PID2 || error "(3) multiop failed"
+
+       wait $PID1 && error "(2) mv succeeded"
+
+       rm -rf $DIR/d1
+}
+run_test 55c "rename vs unlink orphan target dir"
+
+test_55d()
+{
+       touch $DIR/f1
+
+#define OBD_FAIL_MDS_RENAME3              0x155
+       do_facet mds $LCTL set_param fail_loc=0x155
+       mv $DIR/f1 $DIR/$tdir &
+       PID1=$!
+       sleep 2
+
+       # while rename is sleeping, create $tdir, but as a directory
+       mkdir -p $DIR2/$tdir || error "(1) mkdir failed"
+
+       # link in reverse locking order
+       ln $DIR2/f1 $DIR2/$tdir/
+
+       wait $PID1 && error "(2) mv succeeded"
+       rm -rf $DIR/f1
+}
+run_test 55d "rename file vs link"
+
 test_60() {
-       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.0) ]] ||
-       { skip "Need MDS version at least 2.3.0"; return; }
+       local MDSVER=$(lustre_build_version $SINGLEMDS)
+       [ $(version_code $MDSVER) -lt $(version_code 2.3.0) ] &&
+               skip "MDS version $MDSVER must be >= 2.3.0" && return 0
+
        # Create a file
        test_mkdir -p $DIR1/$tdir
        file1=$DIR1/$tdir/file
@@ -2695,14 +2867,9 @@ run_test 75 "osc: upcall after unuse lock==================="
 test_76() { #LU-946
        [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.5.53) ]] &&
                skip "Need MDS version at least 2.5.53" && return
-       [ $MDSCOUNT -ge 2 ] && skip "skip now for LU-4573" && return #LU-4573
 
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
        local fcount=2048
-       local fd
-       local cmd
-       local mdt_idx
-       local mds_idx
        declare -a fd_list
        declare -a fid_list
 
@@ -2714,29 +2881,24 @@ test_76() { #LU-946
 
        rm -rf $DIR/$tdir
        test_mkdir -p $DIR/$tdir
-       if [ $MDSCOUNT -gt 1 ]; then
-               mdt_idx=$($LFS getdirstripe -i $DIR/$tdir)
-       else
-               mdt_idx=0
-       fi
-       mds_idx=$((mdt_idx + 1))
-       proc_ofile="mdt.*$mdt_idx.exports.'$nid'.open_files"
 
+       # drop all open locks and close any cached "open" files on the client
        cancel_lru_locks mdc
 
        echo -n "open files "
        ulimit -n 8096
-       for (( i = 0; i < $fcount; i++ )) ; do
+       for ((i = 0; i < $fcount; i++)); do
                touch $DIR/$tdir/f_$i
-               fd=$(free_fd)
-               cmd="exec $fd<$DIR/$tdir/f_$i"
+               local fd=$(free_fd)
+               local cmd="exec $fd<$DIR/$tdir/f_$i"
                eval $cmd
                fd_list[i]=$fd
                echo -n "."
        done
        echo
 
-       fid_list=($(do_facet mds$mds_idx $LCTL get_param -n $proc_ofile))
+       local get_open_fids="$LCTL get_param -n mdt.*.exports.'$nid'.open_files"
+       local fid_list=($(do_nodes $(comma_list $(mdts_nodes)) $get_open_fids))
 
        # Possible errors in openfiles FID list.
        # 1. Missing FIDs. Check 1
@@ -2769,7 +2931,296 @@ test_76() { #LU-946
 }
 run_test 76 "Verify open file for 2048 files"
 
-test_80() {
+nrs_write_read() {
+       local n=16
+       local dir=$DIR/$tdir
+       local myRUNAS="$1"
+
+       mkdir $dir || error "mkdir $dir failed"
+       $LFS setstripe -c $OSTCOUNT $dir || error "setstripe to $dir failed"
+       chmod 777 $dir
+
+       do_nodes $CLIENTS $myRUNAS dd if=/dev/zero of="$dir/nrs_r_$HOSTNAME"\
+               bs=1M count=$n > /dev/null 2>&1
+
+       for ((i = 0; i < $n; i++)); do
+               do_nodes $CLIENTS $myRUNAS dd if=/dev/zero\
+                       of="$dir/nrs_w_$HOSTNAME" bs=1M seek=$i count=1\
+                        > /dev/null 2>&1 &
+               local pids_w[$i]=$!
+       done
+       do_nodes $CLIENTS sync;
+       cancel_lru_locks osc
+
+       for ((i = 0; i < $n; i++)); do
+               do_nodes $CLIENTS $myRUNAS dd if="$dir/nrs_w_$HOSTNAME"\
+                       of=/dev/zero bs=1M seek=$i count=1 > /dev/null 2>&1 &
+               local pids_r[$i]=$!
+       done
+       cancel_lru_locks osc
+
+       for ((i = 0; i < $n; i++)); do
+               wait ${pids_w[$i]}
+               wait ${pids_r[$i]}
+       done
+       rm -rf $dir || error "rm -rf $dir failed"
+}
+
+test_77a() { #LU-3266
+       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_policies="fifo"
+       nrs_write_read
+
+       return 0
+}
+run_test 77a "check FIFO NRS policy"
+
+
+test_77b() { #LU-3266
+       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_policies="crrn"
+       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_crrn_quantum=1
+
+       echo "policy: crr-n, crrn_quantum 1"
+       nrs_write_read
+
+       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_crrn_quantum=64
+
+       echo "policy: crr-n, crrn_quantum 64"
+       nrs_write_read
+
+       return 0
+}
+run_test 77b "check CRR-N NRS policy"
+
+orr_trr() {
+       local policy=$1
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies=$policy
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_"$policy"_quantum=1
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_"$policy"_offset_type="physical"
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_"$policy"_supported="reads"
+       done
+
+       echo "policy: $policy, ${policy}_quantum 1, ${policy}_offset_type \
+                               physical, ${policy}_supported reads"
+       nrs_write_read
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_${policy}_supported="writes"
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_${policy}_quantum=64
+       done
+       echo "policy: $policy, ${policy}_quantum 64, \
+               ${policy}_offset_type physical, ${policy}_supported writes"
+       nrs_write_read
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_${policy}_supported="reads_and_writes"
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_${policy}_offset_type="logical"
+       done
+       echo "policy: $policy, ${policy}_quantum 64, \
+               ${policy}_offset_type logical, ${policy}_supported reads_and_writes"
+       nrs_write_read
+
+       return 0
+}
+
+test_77c() { #LU-3266
+       orr_trr "orr"
+       return 0
+}
+run_test 77c "check ORR NRS policy"
+
+test_77d() { #LU-3266
+       orr_trr "trr"
+       return 0
+}
+run_test 77d "check TRR nrs policy"
+
+tbf_rule_operate()
+{
+       local facet=$1
+       shift 1
+
+       do_facet $facet lctl set_param \
+               ost.OSS.ost_io.nrs_tbf_rule="$@"
+       [ $? -ne 0 ] &&
+               error "failed to operate on TBF rules"
+}
+
+test_77e() {
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="tbf\ nid"
+               [ $? -ne 0 ] &&
+                       error "failed to set TBF policy"
+       done
+
+       # Only operate rules on ost1 since OSTs might run on the same OSS
+       # Add some rules
+       tbf_rule_operate ost1 "start\ localhost\ {0@lo}\ 1000"
+       local address=$(comma_list "$(host_nids_address $CLIENTS $NETTYPE)")
+       local client_nids=$(nids_list $address "\\")
+       tbf_rule_operate ost1 "start\ clients\ {$client_nids}\ 100"
+       tbf_rule_operate ost1 "start\ others\ {*.*.*.*@$NETTYPE}\ 50"
+       nrs_write_read
+
+       # Change the rules
+       tbf_rule_operate ost1 "change\ localhost\ 1001"
+       tbf_rule_operate ost1 "change\ clients\ 101"
+       tbf_rule_operate ost1 "change\ others\ 51"
+       nrs_write_read
+
+       # Stop the rules
+       tbf_rule_operate ost1 "stop\ localhost"
+       tbf_rule_operate ost1 "stop\ clients"
+       tbf_rule_operate ost1 "stop\ others"
+       nrs_write_read
+
+       # Cleanup the TBF policy
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+               [ $? -ne 0 ] &&
+                       error "failed to set policy back to fifo"
+       done
+       nrs_write_read
+       return 0
+}
+run_test 77e "check TBF NID nrs policy"
+
+test_77f() {
+       # Configure jobid_var
+       local saved_jobid_var=$($LCTL get_param -n jobid_var)
+       if [ $saved_jobid_var != procname_uid ]; then
+               set_conf_param_and_check client                 \
+                       "$LCTL get_param -n jobid_var"          \
+                       "$FSNAME.sys.jobid_var" procname_uid
+       fi
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="tbf\ jobid"
+               [ $? -ne 0 ] &&
+                       error "failed to set TBF policy"
+       done
+
+       # Only operate rules on ost1 since OSTs might run on the same OSS
+       # Add some rules
+       tbf_rule_operate ost1 "start\ runas\ {iozone.$RUNAS_ID\ dd.$RUNAS_ID\ tiotest.$RUNAS_ID}\ 1000"
+       tbf_rule_operate ost1 "start\ iozone_runas\ {iozone.$RUNAS_ID}\ 100"
+       tbf_rule_operate ost1 "start\ dd_runas\ {dd.$RUNAS_ID}\ 50"
+       nrs_write_read "$RUNAS"
+
+       # Change the rules
+       tbf_rule_operate ost1 "change\ runas\ 1001"
+       tbf_rule_operate ost1 "change\ iozone_runas\ 101"
+       tbf_rule_operate ost1 "change\ dd_runas\ 51"
+       nrs_write_read "$RUNAS"
+
+       # Stop the rules
+       tbf_rule_operate ost1 "stop\ runas"
+       tbf_rule_operate ost1 "stop\ iozone_runas"
+       tbf_rule_operate ost1 "stop\ dd_runas"
+       nrs_write_read "$RUNAS"
+
+       # Cleanup the TBF policy
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+               [ $? -ne 0 ] &&
+                       error "failed to set policy back to fifo"
+       done
+       nrs_write_read "$RUNAS"
+
+       local current_jobid_var=$($LCTL get_param -n jobid_var)
+       if [ $saved_jobid_var != $current_jobid_var ]; then
+               set_conf_param_and_check client                 \
+                       "$LCTL get_param -n jobid_var"          \
+                       "$FSNAME.sys.jobid_var" $saved_jobid_var
+       fi
+       return 0
+}
+run_test 77f "check TBF JobID nrs policy"
+
+test_77g() {
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="tbf\ nid"
+               [ $? -ne 0 ] &&
+                       error "failed to set TBF policy"
+       done
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="tbf\ jobid"
+               [ $? -ne 0 ] &&
+                       error "failed to set TBF policy"
+       done
+
+       # Add a rule that only valid for Jobid TBF. If direct change between
+       # TBF types is not supported, this operation will fail.
+       tbf_rule_operate ost1 "start\ dd_runas\ {dd.$RUNAS_ID}\ 50"
+
+       # Cleanup the TBF policy
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+               [ $? -ne 0 ] &&
+                       error "failed to set policy back to fifo"
+       done
+       return 0
+}
+run_test 77g "Change TBF type directly"
+
+test_78() { #LU-6673
+       local rc
+
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="orr" &
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.*.nrs_orr_quantum=1
+               rc=$?
+               # Valid return codes are:
+               # 0: Tuning succeeded
+               # ENODEV: Policy is still stopped
+               # EAGAIN: Policy is being initialized
+               [ $rc -eq 0 -o $rc -eq 19 -o $rc -eq 11 ] ||
+                       error "Expected set_param to return 0|ENODEV|EAGAIN"
+       done
+
+       # Cleanup the ORR policy
+       for i in $(seq 1 $OSTCOUNT)
+       do
+               do_facet ost"$i" lctl set_param \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+               [ $? -ne 0 ] &&
+                       error "failed to set policy back to fifo"
+       done
+       return 0
+}
+run_test 78 "Enable policy and specify tunings right away"
+
+test_80a() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
        local MDTIDX=1
        local mdt_index
@@ -2789,12 +3240,12 @@ test_80() {
        # give multiop a chance to open
        sleep 1
 
-       $LFS mv -M $MDTIDX $DIR1/$tdir &&
+       $LFS migrate -m $MDTIDX $DIR1/$tdir &&
                error "migrate open files should failed with open files"
 
        kill -USR1 $pid
 
-       $LFS mv -M $MDTIDX $DIR1/$tdir ||
+       $LFS migrate -m $MDTIDX $DIR1/$tdir ||
                        error "migrate remote dir error"
 
        echo "Finish migration, then checking.."
@@ -2809,10 +3260,320 @@ test_80() {
 
        rm -rf $DIR1/$tdir || error "rm dir failed after migration"
 }
-run_test 80 "migrate directory when some children is being opened"
+run_test 80a "migrate directory when some children is being opened"
+
+cleanup_80b() {
+       trap 0
+       kill -9 $migrate_pid
+}
+
+test_80b() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local migrate_dir1=$DIR1/$tdir/migrate_dir
+       local migrate_dir2=$DIR2/$tdir/migrate_dir
+       local migrate_run=$LUSTRE/tests/migrate.sh
+       local start_time
+       local end_time
+       local show_time=1
+       local mdt_idx
+       local rc=0
+       local rc1=0
+
+       trap cleanup_80b EXIT
+       #prepare migrate directory
+       mkdir -p $migrate_dir1
+       for F in {1,2,3,4,5}; do
+               echo "$F$F$F$F$F" > $migrate_dir1/file$F
+               echo "$F$F$F$F$F" > $DIR/$tdir/file$F
+       done
+
+       #migrate the directories among MDTs
+       (
+               while true; do
+                       mdt_idx=$((RANDOM % MDSCOUNT))
+                       $LFS migrate -m $mdt_idx $migrate_dir1 2&>/dev/null ||
+                               rc=$?
+                       [ $rc -ne 0 -o $rc -ne 16 ] || break
+               done
+       ) &
+       migrate_pid=$!
+
+       echo "start migration thread $migrate_pid"
+       #Access the files at the same time
+       start_time=$(date +%s)
+       echo "accessing the migrating directory for 5 minutes..."
+       while true; do
+               ls $migrate_dir2 > /dev/null || {
+                       echo "read dir fails"
+                       break
+               }
+               diff -u $DIR2/$tdir/file1 $migrate_dir2/file1 || {
+                       echo "access file1 fails"
+                       break
+               }
+
+               cat $migrate_dir2/file2 > $migrate_dir2/file3 || {
+                       echo "access file2/3 fails"
+                       break
+               }
+
+               echo "aaaaa" > $migrate_dir2/file4 > /dev/null || {
+                       echo "access file4 fails"
+                       break
+               }
+
+               stat $migrate_dir2/file5 > /dev/null || {
+                       echo "stat file5 fails"
+                       break
+               }
+
+               touch $migrate_dir2/source_file > /dev/null || rc1=$?
+               [ $rc1 -ne 0 -o $rc1 -ne 1 ] || {
+                       echo "touch file failed with $rc1"
+                       break;
+               }
+
+               if [ -e $migrate_dir2/source_file ]; then
+                       ln $migrate_dir2/source_file $migrate_dir2/link_file \
+                                       2&>/dev/null || rc1=$?
+                       if [ -e $migrate_dir2/link_file ]; then
+                               rm -rf $migrate_dir2/link_file
+                       fi
+
+                       mrename $migrate_dir2/source_file \
+                               $migrate_dir2/target_file 2&>/dev/null || rc1=$?
+                       [ $rc1 -ne 0 -o $rc1 -ne 1 ] || {
+                               echo "rename failed with $rc1"
+                               break
+                       }
+
+                       if [ -e $migrate_dir2/target_file ]; then
+                               rm -rf $migrate_dir2/target_file 2&>/dev/null ||
+                                                               rc1=$?
+                       else
+                               rm -rf $migrate_dir2/source_file 2&>/dev/null ||
+                                                               rc1=$?
+                       fi
+                       [ $rc1 -ne 0 -o $rc1 -ne 1 ] || {
+                               echo "unlink failed with $rc1"
+                               break
+                       }
+               fi
+
+               end_time=$(date +%s)
+               duration=$((end_time - start_time))
+               if [ $((duration % 10)) -eq 0 ]; then
+                       if [ $show_time -eq 1 ]; then
+                               echo "...$duration seconds"
+                               show_time=0
+                       fi
+               else
+                       show_time=1
+               fi
+
+               kill -0 $migrate_pid || {
+                       echo "migration stopped 1"
+                       break
+               }
+
+               [ $duration -ge 300 ] && break
+       done
+
+       #check migration are still there
+       kill -0 $migrate_pid || error "migration stopped 2"
+       cleanup_80b
+}
+run_test 80b "Accessing directory during migration"
+
+test_81() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       rm -rf $DIR1/$tdir
+
+       mkdir -p $DIR1/$tdir
+
+       $LFS setdirstripe -i0 -c$MDSCOUNT  $DIR1/$tdir/d0
+       $LFS setdirstripe -i0 -c$MDSCOUNT  $DIR1/$tdir/d1
+
+       cd $DIR1/$tdir
+       touch d0/0      || error "create 0 failed"
+       mv d0/0 d1/0    || error "rename d0/0 d1/0 failed"
+       stat d0/0       && error "stat mv filed succeed"
+       mv $DIR2/$tdir/d1/0 $DIR2/$tdir/d0/0 || "rename d1/0 d0/0 failed"
+       stat d0/0       || error "stat failed"
+
+       local t=$(ls -ai $DIR1/$tdir/d0 | sort -u | wc -l)
+
+       if [ $t -ne 3 ]; then
+               ls -ai $DIR1/$tdir/d0
+               error "expect 3 get $t"
+       fi
+
+       return 0
+}
+run_test 81 "rename and stat under striped directory"
+
+test_82() {
+       [[ $(lustre_version_code $SINGLEMDS) -gt $(version_code 2.6.91) ]] ||
+               { skip "Need MDS version at least 2.6.92"; return 0; }
+
+       # Client 1 creates a file.
+       multiop_bg_pause $DIR1/$tfile O_ac || error "multiop_bg_pause 1"
+       pid1=$!
+       # Client 2 opens the file.
+       multiop_bg_pause $DIR2/$tfile o_Ac || error "multiop_bg_pause 2"
+       pid2=$!
+       # Client 1 makes the file an orphan.
+       rm $DIR1/$tfile || error "rm"
+       # Client 2 sets EA "user.multiop".
+       kill -s USR1 $pid2
+       wait $pid2 || error "multiop 2"
+       # Client 1 gets EA "user.multiop".  This used to fail because the EA
+       # cache refill would get "trusted.link" from mdd_xattr_list() but
+       # -ENOENT when trying to get "trusted.link"'s value.  See also sanity
+       # 102q.
+       kill -s USR1 $pid1
+       wait $pid1 || error "multiop 1"
+}
+run_test 82 "fsetxattr and fgetxattr on orphan files"
+
+test_83() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local pid1
+       local pid2
+
+       (
+               cd $DIR1
+               while true; do
+                       $LFS mkdir -i1 -c2 $tdir
+                       rmdir $tdir
+               done
+       ) &
+       pid1=$!
+       echo "start pid $pid1 to create/unlink striped directory"
+
+       # Access the directory at the same time
+       (
+               cd $DIR2
+               while true; do
+                       stat $tdir > /dev/null 2>&1
+               done
+       ) &
+       pid2=$!
+       echo "start pid $pid2 to stat striped directory"
+
+       sleep 120
+       kill $pid1 $pid2
+       wait $pid1 $pid2
+
+       return 0
+}
+run_test 83 "access striped directory while it is being created/unlinked"
+
+test_90() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local pid1
+       local pid2
+       local duration=180
+
+       [ "$SLOW" = "yes" ] && duration=600
+       # Open/Create under striped directory
+       (
+               cd $DIR1
+               while true; do
+                       $LFS mkdir -c$MDSCOUNT $tdir > /dev/null 2>&1
+                       touch $tdir/f{0..3} > /dev/null 2>&1
+               done
+       ) &
+       pid1=$!
+       echo "start pid $pid1 to open/create under striped directory"
+
+       # unlink the striped directory at the same time
+       (
+               cd $DIR2
+               while true; do
+                       rm -rf $tdir > /dev/null 2>&1
+               done
+       ) &
+       pid2=$!
+       echo "start pid $pid2 to unlink striped directory"
+
+       sleep $duration
+
+       kill $pid1 $pid2
+       wait $pid1 $pid2
+
+       return 0
+}
+run_test 90 "open/create and unlink striped directory"
+
+test_91() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local pid1
+       local pid2
+       local duration=180
+
+       [ "$SLOW" = "yes" ] && duration=600
+       # chmod striped directory
+       (
+               cd $DIR1
+               while true; do
+                       $LFS mkdir -c$MDSCOUNT $tdir > /dev/null 2>&1
+                       chmod go+w $tdir > /dev/null 2>&1
+               done
+       ) &
+       pid1=$!
+       echo "start pid $pid1 to chmod striped directory"
+
+       # unlink the striped directory at the same time
+       (
+               cd $DIR2
+               while true; do
+                       rm -rf $tdir > /dev/null 2>&1
+               done
+       ) &
+       pid2=$!
+       echo "start pid $pid2 to unlink striped directory"
+
+       sleep $duration
+
+       kill $pid1 $pid2
+       wait $pid1 $pid2
+
+       return 0
+}
+run_test 91 "chmod and unlink striped directory"
+
+test_92() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       local fd=$(free_fd)
+       local cmd="exec $fd<$DIR1/$tdir"
+       $LFS setdirstripe -c$MDSCOUNT $DIR1/$tdir || error "mkdir $tdir fails"
+       eval $cmd
+       cmd="exec $fd<&-"
+       trap "eval $cmd" EXIT
+       cd $DIR1/$tdir || error "cd $DIR1/$tdir fails"
+       rmdir ../$tdir || error "rmdir ../$tdir fails"
+
+       #define OBD_FAIL_LLITE_NO_CHECK_DEAD  0x1408
+       $LCTL set_param fail_loc=0x1408
+       mkdir $DIR2/$tdir/dir && error "create dir succeeds"
+       $LFS setdirstripe -i1 $DIR2/$tdir/remote_dir &&
+               error "create remote dir succeeds"
+       $LCTL set_param fail_loc=0
+       eval $cmd
+       return 0
+}
+run_test 92 "create remote directory under orphan directory"
 
 log "cleanup: ======================================================"
 
+# kill and wait in each test only guarentee script finish, but command in script
+# like 'rm' 'chmod' may still be running, wait for all commands to finish
+# otherwise umount below will fail
+wait_update $HOSTNAME "fuser -m $MOUNT2" "" || true
+
 [ "$(mount | grep $MOUNT2)" ] && umount $MOUNT2
 
 complete $SECONDS